> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gomaestro.org/llms.txt
> Use this file to discover all available pages before exploring further.

> Get list of addresses holding a specific Cardano native asset with balance amounts and distribution statistics.

# Native asset addresses



## OpenAPI

````yaml cardano/blockchain-indexer-api/openapi.json get /assets/{asset}/addresses
openapi: 3.0.3
info:
  title: Cardano - Blockchain Indexer API
  description: Core indexer endpoints dedicated to Cardano.
  contact:
    name: Maestro Blockchain Inc.
    url: https://gomaestro.org/
    email: info@gomaestro.org
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.txt
  version: v1.8.0
servers:
  - url: https://mainnet.gomaestro-api.org/v1
    description: Cardano Mainnet
  - url: https://preprod.gomaestro-api.org/v1
    description: Cardano Preprod
  - url: https://preview.gomaestro-api.org/v1
    description: Cardano Preview
security:
  - api-key: []
tags:
  - name: Maestro
paths:
  /assets/{asset}/addresses:
    get:
      tags:
        - Assets
      summary: Native asset addresses
      description: >-
        Returns a list of addresses which control some amount of the specified
        asset
      operationId: asset_addresses
      parameters:
        - name: asset
          in: path
          description: Asset, encoded as concatenation of hex of policy ID and asset name
          required: true
          schema:
            type: string
        - name: count
          in: query
          description: The max number of results per page
          required: false
          schema:
            allOf:
              - type: integer
                default: 100
                minimum: 0
            nullable: true
        - name: cursor
          in: query
          description: >-
            Pagination cursor string, use the cursor included in a page of
            results to fetch the next page
          required: false
          schema:
            type: string
            nullable: true
        - name: amounts-as-strings
          in: header
          description: Large numbers returned as strings if set to `true`
          required: false
          schema:
            type: string
            nullable: true
      responses:
        '200':
          description: >-
            Returns addresses holding the specified asset, paired with the
            amounts of the asset owned
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedAssetHolder'
              example:
                data:
                  - address: >-
                      addr_test1vpxa84r650wsmcm887kkwar5y7ek5yyrjvgfqd8a608s2vsdnutyy
                    amount: 100000000000000
                  - address: >-
                      addr_test1vrjpwhg7vlhck0ph5q0dpnkqferx3ltf0aqvy4qzn9m5v2gcvqhm8
                    amount: 320000000000000
                last_updated:
                  timestamp: '2022-10-10 20:25:28'
                  block_hash: >-
                    c0d2cf4d7e0e9dfbfda2e09330a8aa2dd426a0d9c2d927ea28e43aa0b6550f8f
                  block_slot: 32266746
                next_cursor: null
        '400':
          description: Malformed query parameters
        '500':
          description: Internal server error
components:
  schemas:
    PaginatedAssetHolder:
      type: object
      description: >-
        A paginated response. Pass in the `next_cursor` in a subsequent request
        as the `cursor` query parameter to fetch the next page of results.
      required:
        - data
        - last_updated
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/AssetHolder'
          description: Endpoint response data
        last_updated:
          $ref: '#/components/schemas/LastUpdated'
        next_cursor:
          type: string
          description: Pagination cursor
          nullable: true
    AssetHolder:
      type: object
      description: Holder of a specific asset
      required:
        - address
        - amount
      properties:
        address:
          type: string
          description: Address of the holder
        amount:
          $ref: '#/components/schemas/NumOrString'
    LastUpdated:
      type: object
      description: >-
        Details of the most recent block processed by the indexer (aka chain
        tip); that is, the data returned is correct as of this block in time.
      required:
        - timestamp
        - block_hash
        - block_slot
      properties:
        block_hash:
          type: string
          description: >-
            Hex-encoded hash of the most recently processed block (aka chain
            tip)
        block_slot:
          type: integer
          format: int64
          description: Absolute slot of the most recently processed block (aka chain tip)
          minimum: 0
        timestamp:
          type: string
          description: UTC timestamp of when the most recently processed block was minted
    NumOrString:
      oneOf:
        - type: integer
          format: int64
          description: Unsigned 64-bit integer
          minimum: 0
        - type: integer
          description: Unsigned 128-bit integer
          minimum: 0
        - type: integer
          format: int64
          description: Signed 64-bit integer
        - type: number
          format: double
          description: 64-bit floating point number
        - type: string
          description: String representation of an integer or number
      description: >-
        Integer or number by default, or a string representation if the
        `amounts-as-strings` header is set to `true`
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: api-key
      description: Project API Key

````